diff a/installers/linux/universal/deb/build.gradle b/installers/linux/universal/deb/build.gradle
--- /dev/null
+++ b/installers/linux/universal/deb/build.gradle
@@ -0,0 +1,209 @@
+/*
+ * Copyright Amazon.com Inc. or its affiliates. All Rights Reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation. Amazon designates this
+ * particular file as subject to the "Classpath" exception as provided
+ * by Oracle in the LICENSE file that accompanied this code.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ */
+
+plugins {
+    id 'com.netflix.nebula.ospackage' version 'latest.release'
+}
+
+dependencies {
+    compile project(path: ':installers:linux:universal:tar', configuration: 'archives')
+}
+
+ext {
+    switch (project.correttoArch) {
+        case 'aarch64':
+            arch_deb = 'arm64'
+            break;
+        case 'x86':
+            arch_deb = "i386"
+            break
+        case 'x64':
+            arch_deb = 'amd64'
+            break
+    }
+}
+
+def jvmDir = '/usr/lib/jvm'
+def jdkInstallationDirName = "java-${project.version.major}-amazon-corretto"
+def jdkHome = "${jvmDir}/${jdkInstallationDirName}".toString()
+def jdkBinaryDir = "${buildRoot}/${project.correttoJdkArchiveName}"
+def jdkPackageName = "java-${project.version.major}-amazon-corretto-jdk"
+
+def alternativesPriority = String.format("1%2s%2s%3s", project.version.major, project.version.minor, project.version.security).replace(' ', '0')
+
+def jinfoName = ".${jdkInstallationDirName}.jinfo"
+
+ospackage {
+    // Valid version must start with a digit and only contain [A-Za-z0-9.+:~-]
+    // See http://manpages.ubuntu.com/manpages/artful/en/man5/deb-version.5.html
+    version = project.version.upstream
+    release = project.version.revision
+
+    url = "${packageInfo.url}"
+    vendor = "${packageInfo.vendor}"
+    packager = "${packageInfo.packager}"
+    license = "${packageInfo.license}"
+    buildHost = "${packageInfo.buildHost}"
+    maintainer = "${packageInfo.maintainer}"
+    packageGroup = 'java'
+    priority = 'optional'
+    user = 'root'
+    permissionGroup = 'root'
+    epoch = 1
+    arch = arch_deb
+    multiArch = SAME
+}
+
+/**
+ * Uncompress and copy the universal Corretto artifact
+ * tar for DEB packaging.
+ */
+task extractUniversalTar(type: Copy) {
+    dependsOn project.configurations.compile
+    from tarTree(project.configurations.compile.singleFile)
+    into buildRoot
+}
+
+/**
+ * Populate version numbers, java home and alternatives
+ * priority to postin_jdk.sh.template and preun_jdk.sh.template.
+ * Create script copies under build root scripts folder.
+ */
+task inflateDebScriptTemplate(type: Copy) {
+    dependsOn extractUniversalTar
+    // In trusty repo, openjdk7 has priority 1071 and openjdk6 has 1061
+    // Corretto uses the same priority in both rpm and deb
+    def priority =
+            from('scripts') {
+                include '**/*.template'
+                rename { file -> file.replace('.template', '') }
+                filter(org.apache.tools.ant.filters.ReplaceTokens,
+                        tokens: project.version + [java_home: jdkHome, alternatives_priority: alternativesPriority,
+                                                   jdk_tools: jdkTools.join(' ')])
+            }
+    into "${buildRoot}/scripts"
+}
+
+/**
+ * Inflate jinfo file used by update-java-alternatives command.
+ * Create script copy under buildRoot/jinfo folder. See
+ * http://manpages.ubuntu.com/manpages/xenial/man8/update-java-alternatives.8.html#files
+ */
+task inflateJinfoTemplate(type: Copy) {
+    from('jinfo') {
+        include '**/*.template'
+        rename('jinfo.template', jinfoName)
+        filter(org.apache.tools.ant.filters.ReplaceTokens,
+                tokens: project.version + [java_home     : jdkHome, alternatives_priority: alternativesPriority,
+                                           directory_name: jdkInstallationDirName.toString()])
+        expand(jdk_tools: jdkTools)
+    }
+    into "${buildRoot}/jinfo"
+}
+
+/**
+ * Generate DEB for JDK, with package published under
+ * distributions folder.
+ */
+task generateJdkDeb(type: Deb) {
+    description = 'Create the DEB package for Corretto JDK'
+    dependsOn inflateDebScriptTemplate
+    dependsOn inflateJinfoTemplate
+
+    packageName = jdkPackageName
+    packageDescription = "Amazon Corretto\'s packaging of the OpenJDK ${project.version.major} code."
+    summary = "Amazon Corretto ${project.version.major} development environment"
+
+    postInstall file("$buildRoot/scripts/postin_jdk.sh")
+    preUninstall file("$buildRoot/scripts/preun_jdk.sh")
+
+    requires('java-common')
+    requires('zlib1g')
+    // jdk
+    provides('java-compiler')
+    provides('java-sdk')
+    provides('java5-sdk')
+    provides('java6-sdk')
+    provides('java7-sdk')
+    provides('java7-jdk')
+    provides('java8-jdk')
+    provides('java11-sdk')
+    17.upto(project.version.major.toInteger()) {
+      provides("java${it}-sdk")
+    }
+    // TODO: Move this to the jre when splitting the fat deb
+    provides('java-runtime')
+    provides('java5-runtime')
+    provides('java6-runtime')
+    provides('java7-runtime')
+    provides('java8-runtime')
+    provides('java11-runtime')
+    17.upto(project.version.major.toInteger()) {
+      provides("java${it}-runtime")
+    }
+    // TODO: Move this to the headless jre when splitting the fat deb
+    provides('java-runtime-headless')
+    provides('java5-runtime-headless')
+    provides('java6-runtime-headless')
+    provides('java7-runtime-headless')
+    provides('java8-runtime-headless')
+    provides('java11-runtime-headless')
+    17.upto(project.version.major.toInteger()) {
+      provides("java${it}-runtime-headless")
+    }
+
+    from(jdkBinaryDir) {
+        include(project.configurationFiles)
+        // Deb actually uses configuationFile and not fileType see https://github.com/nebula-plugins/gradle-ospackage-plugin/issues/118#issuecomment-656004360
+        // Path must be the fully qualified install path
+        configurationFile = project.configurationFiles.collect{ "${jdkHome}/${it}" }.join("\n")
+        into jdkHome
+    }
+
+    from(jdkBinaryDir) {
+        into jdkHome
+        exclude 'legal'
+        exclude(project.configurationFiles)
+    }
+
+    // Copy legal directory specifically to set permission correctly.
+    // See https://github.com/corretto/corretto-11/issues/129
+    from("${jdkBinaryDir}/legal") {
+        into "${jdkHome}/legal"
+        fileMode = 0444
+    }
+
+    if (!project.excludeReadmeJavaSE) {
+        from("${jdkBinaryDir}/README.JAVASE") {
+            into jdkHome
+            fileMode = 0444
+        }
+    }
+
+    from("${buildRoot}/jinfo") {
+        include '**/*.jinfo'
+        into jvmDir
+    }
+}
+
+artifacts {
+    archives generateJdkDeb
+}
diff a/installers/linux/universal/deb/jinfo/jinfo.template b/installers/linux/universal/deb/jinfo/jinfo.template
--- /dev/null
+++ b/installers/linux/universal/deb/jinfo/jinfo.template
@@ -0,0 +1,7 @@
+name=@directory_name@
+alias=@directory_name@
+priority=@alternatives_priority@
+section=main
+
+<% jdk_tools.each {%>jdk ${it} @java_home@/bin/${it}
+<%}%>
diff a/installers/linux/universal/deb/scripts/postin_jdk.sh.template b/installers/linux/universal/deb/scripts/postin_jdk.sh.template
--- /dev/null
+++ b/installers/linux/universal/deb/scripts/postin_jdk.sh.template
@@ -0,0 +1,19 @@
+# postinst script for Corretto
+#
+# summary of how this script can be called:
+#        * <postinst> `configure' <most-recently-configured-version>
+# for details, see https://www.debian.org/doc/debian-policy/ch-maintainerscripts.html or
+# the debian-policy package
+
+
+# Note that Nebula gradle-ospackage-plugin default and only support `configure` option for post installation script.
+
+for i in @jdk_tools@; do
+    if [ -e @java_home@/bin/$i ]; then
+        cmd="update-alternatives --install /usr/bin/$i $i @java_home@/bin/$i @alternatives_priority@"
+        if [ -e @java_home@/man/man1/$i.1 ]; then
+            cmd="$cmd --slave /usr/share/man/man1/$i.1 $i.1 @java_home@/man/man1/$i.1"
+        fi
+        $cmd
+    fi
+done
diff a/installers/linux/universal/deb/scripts/preun_jdk.sh.template b/installers/linux/universal/deb/scripts/preun_jdk.sh.template
--- /dev/null
+++ b/installers/linux/universal/deb/scripts/preun_jdk.sh.template
@@ -0,0 +1,18 @@
+# postrm script for Corretto
+#
+# summary of how this script can be called:
+#        * <postrm> `remove'
+# for details, see https://www.debian.org/doc/debian-policy/ch-maintainerscripts.html or
+# the debian-policy package
+
+case "$1" in
+    remove | deconfigure)
+        for i in @jdk_tools@; do
+            if [ -e @java_home@/bin/$i ]; then
+                update-alternatives --remove $i @java_home@/bin/$i
+            fi
+        done
+    ;;
+esac
+
+exit 0
diff a/installers/linux/universal/rpm/build.gradle b/installers/linux/universal/rpm/build.gradle
--- /dev/null
+++ b/installers/linux/universal/rpm/build.gradle
@@ -0,0 +1,159 @@
+/*
+ * Copyright Amazon.com Inc. or its affiliates. All Rights Reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation. Amazon designates this
+ * particular file as subject to the "Classpath" exception as provided
+ * by Oracle in the LICENSE file that accompanied this code.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ */
+
+plugins {
+    id 'com.netflix.nebula.ospackage' version 'latest.release'
+}
+
+dependencies {
+    compile project(path: ':installers:linux:universal:tar', configuration: 'archives')
+}
+
+ext {
+    switch (project.correttoArch) {
+        case 'aarch64':
+            arch_redline = 'AARCH64'
+            break;
+        case 'x86':
+            arch_redline = "i386"
+            break
+        case 'x64':
+            arch_redline = 'x86_64'
+            break
+    }
+}
+
+def jvmDir = '/usr/lib/jvm'
+def jdkInstallationDirName = "java-${project.version.major}-amazon-corretto"
+def jdkHome = "${jvmDir}/${jdkInstallationDirName}"
+def jdkBinaryDir = "${buildRoot}/${project.correttoJdkArchiveName}"
+def jdkPackageName = "java-${project.version.major}-amazon-corretto-devel"
+
+ospackage {
+    version = project.version.upstream
+    release = project.version.revision
+
+    url = "${packageInfo.url}"
+    vendor = "${packageInfo.vendor}"
+    packager = "${packageInfo.packager}"
+    license = "${packageInfo.license}"
+    buildHost = "${packageInfo.buildHost}"
+    user = 'root'
+    permissionGroup = 'root'
+    epoch = 1
+    arch = arch_redline
+    os = LINUX
+    type = BINARY
+}
+
+/**
+ * Uncompress and copy the universal Corretto artifact
+ * tar for RPM packaging.
+ */
+task extractUniversalTar(type: Copy) {
+    dependsOn project.configurations.compile
+    from tarTree(project.configurations.compile.singleFile)
+    into buildRoot
+}
+
+/**
+ * Populate version numbers, java home and alternatives
+ * priority to postin_javac.sh.template and preun_javac.sh.template.
+ * Create script copies under build root scripts folder.
+ */
+task inflateRpmScriptTemplate(type: Copy) {
+    dependsOn extractUniversalTar
+    // Use the same priority as IcedTea JDK RPM distribution, based on java version
+    def priority = String.format("1%2s%2s%3s", project.version.major, project.version.minor, project.version.security).replace(' ', '0')
+    from('scripts') {
+        include '**/*.template'
+        rename { file -> file.replace('.template', '') }
+        filter(org.apache.tools.ant.filters.ReplaceTokens,
+                tokens: project.version + [alternatives_priority: priority])
+    }
+    into "${buildRoot}/scripts"
+}
+
+/**
+ * Generate RPM for JDK, with package published under
+ * distributions folder.
+ */
+task generateJdkRpm(type: Rpm) {
+    description = 'Create the RPM package for Corretto JDK'
+    dependsOn inflateRpmScriptTemplate
+    packageName = jdkPackageName
+    packageDescription = packageInfo.description
+    summary = "Amazon Corretto ${project.version.major} development environment"
+    packageGroup = 'Development/Tools'
+    // Remove after https://github.com/nebula-plugins/gradle-ospackage-plugin/issues/401 is merged and released
+    sourcePackage = "${jdkPackageName}-${project.version.major}.${project.version.minor}.${project.version.security}.${project.version.build}-${project.version.revision}.src.rpm"
+
+    prefix(jdkHome)
+    postInstall file("$buildRoot/scripts/postin_java.sh")
+    postInstall file("$buildRoot/scripts/postin_javac.sh")
+    preUninstall file("$buildRoot/scripts/preun_java.sh")
+    preUninstall file("$buildRoot/scripts/preun_javac.sh")
+
+    requires('zlib')
+
+    provides(jdkPackageName, "${epoch}:${version}-${release}", EQUAL)
+    provides("java", "${epoch}:${version}-${release}", EQUAL)
+    provides("java-${project.version.major}-devel", "${epoch}:${version}", EQUAL)
+    provides("java-${project.version.major}-openjdk-devel", "${epoch}:${version}", EQUAL)
+    provides("java-${project.version.major}-openjdk-devel", "${epoch}:${version}-${release}", EQUAL)
+    provides("java-sdk-${project.version.major}", "${epoch}:${version}", EQUAL)
+    provides("java-sdk-${project.version.major}-openjdk", "${epoch}:${version}-${release}", EQUAL)
+    provides("java-${project.version.major}", "${epoch}:${version}", EQUAL)
+    provides("java-${project.version.major}-openjdk", "${epoch}:${version}", EQUAL)
+    provides("jre", "${epoch}:${version}", EQUAL)
+    provides("jre-${project.version.major}", "${epoch}:${version}", EQUAL)
+    provides("jre-${project.version.major}-openjdk", "${epoch}:${version}", EQUAL)
+
+    from(jdkBinaryDir) {
+        include(project.configurationFiles)
+        fileType CONFIG | NOREPLACE
+        into jdkHome
+    }
+
+    from(jdkBinaryDir) {
+        into jdkHome
+        exclude 'legal'
+        exclude(project.configurationFiles)
+    }
+
+    // Copy legal directory specifically to set permission correctly.
+    // See https://github.com/corretto/corretto-11/issues/129
+    from("${jdkBinaryDir}/legal") {
+        into "${jdkHome}/legal"
+        fileMode = 0444
+    }
+
+    if (!project.excludeReadmeJavaSE) {
+        from("${jdkBinaryDir}/README.JAVASE") {
+            into jdkHome
+            fileMode = 0444
+        }
+    }   
+}
+
+artifacts {
+    archives generateJdkRpm
+}
diff a/installers/linux/universal/rpm/scripts/postin_java.sh.template b/installers/linux/universal/rpm/scripts/postin_java.sh.template
--- /dev/null
+++ b/installers/linux/universal/rpm/scripts/postin_java.sh.template
@@ -0,0 +1,17 @@
+if [ $1 -eq 1 ] ; then
+     alternatives --install /usr/bin/java java ${RPM_INSTALL_PREFIX}/bin/java @alternatives_priority@ \
+                  --slave /usr/lib/jvm/jre jre ${RPM_INSTALL_PREFIX} \
+                  --slave /usr/bin/jjs jjs ${RPM_INSTALL_PREFIX}/bin/jjs \
+                  --slave /usr/bin/keytool keytool ${RPM_INSTALL_PREFIX}/bin/keytool \
+                  --slave /usr/bin/pack200 pack200 ${RPM_INSTALL_PREFIX}/bin/pack200 \
+                  --slave /usr/bin/rmid rmid ${RPM_INSTALL_PREFIX}/bin/rmid \
+                  --slave /usr/bin/rmiregistry rmiregistry ${RPM_INSTALL_PREFIX}/bin/rmiregistry \
+                  --slave /usr/bin/unpack200 unpack200 ${RPM_INSTALL_PREFIX}/bin/unpack200 \
+                  --slave /usr/share/man/man1/java.1 java.1 ${RPM_INSTALL_PREFIX}/man/man1/java.1 \
+                  --slave /usr/share/man/man1/jjs.1 jjs.1 ${RPM_INSTALL_PREFIX}/man/man1/jjs.1 \
+                  --slave /usr/share/man/man1/keytool.1 keytool.1 ${RPM_INSTALL_PREFIX}/man/man1/keytool.1 \
+                  --slave /usr/share/man/man1/pack200.1 pack200.1 ${RPM_INSTALL_PREFIX}/man/man1/pack200.1 \
+                  --slave /usr/share/man/man1/rmid.1 rmid.1 ${RPM_INSTALL_PREFIX}/man/man1/rmid.1 \
+                  --slave /usr/share/man/man1/rmiregistry.1 rmiregistry.1 ${RPM_INSTALL_PREFIX}/man/man1/rmiregistry.1 \
+                  --slave /usr/share/man/man1/unpack200.1 unpack200.1 ${RPM_INSTALL_PREFIX}/man/man1/unpack200.1
+fi
diff a/installers/linux/universal/rpm/scripts/postin_javac.sh.template b/installers/linux/universal/rpm/scripts/postin_javac.sh.template
--- /dev/null
+++ b/installers/linux/universal/rpm/scripts/postin_javac.sh.template
@@ -0,0 +1,46 @@
+if [ $1 -eq 1 ] ; then
+    alternatives --install /usr/bin/javac javac ${RPM_INSTALL_PREFIX}/bin/javac @alternatives_priority@ \
+                 --slave /usr/lib/jvm/java java_sdk ${RPM_INSTALL_PREFIX} \
+                 --slave /usr/bin/jaotc jaotc ${RPM_INSTALL_PREFIX}/bin/jaotc \
+                 --slave /usr/bin/jlink jlink ${RPM_INSTALL_PREFIX}/bin/jlink \
+                 --slave /usr/bin/jmod jmod ${RPM_INSTALL_PREFIX}/bin/jmod \
+                 --slave /usr/bin/jhsdb jhsdb ${RPM_INSTALL_PREFIX}/bin/jhsdb \
+                 --slave /usr/bin/jar jar ${RPM_INSTALL_PREFIX}/bin/jar \
+                 --slave /usr/bin/jarsigner jarsigner ${RPM_INSTALL_PREFIX}/bin/jarsigner \
+                 --slave /usr/bin/javadoc javadoc ${RPM_INSTALL_PREFIX}/bin/javadoc \
+                 --slave /usr/bin/javap javap ${RPM_INSTALL_PREFIX}/bin/javap \
+                 --slave /usr/bin/jcmd jcmd ${RPM_INSTALL_PREFIX}/bin/jcmd \
+                 --slave /usr/bin/jconsole jconsole ${RPM_INSTALL_PREFIX}/bin/jconsole \
+                 --slave /usr/bin/jdb jdb ${RPM_INSTALL_PREFIX}/bin/jdb \
+                 --slave /usr/bin/jdeps jdeps ${RPM_INSTALL_PREFIX}/bin/jdeps \
+                 --slave /usr/bin/jdeprscan jdeprscan ${RPM_INSTALL_PREFIX}/bin/jdeprscan \
+                 --slave /usr/bin/jimage jimage ${RPM_INSTALL_PREFIX}/bin/jimage \
+                 --slave /usr/bin/jinfo jinfo ${RPM_INSTALL_PREFIX}/bin/jinfo \
+                 --slave /usr/bin/jmap jmap ${RPM_INSTALL_PREFIX}/bin/jmap \
+                 --slave /usr/bin/jps jps ${RPM_INSTALL_PREFIX}/bin/jps \
+                 --slave /usr/bin/jrunscript jrunscript ${RPM_INSTALL_PREFIX}/bin/jrunscript \
+                 --slave /usr/bin/jshell jshell ${RPM_INSTALL_PREFIX}/bin/jshell \
+                 --slave /usr/bin/jstack jstack ${RPM_INSTALL_PREFIX}/bin/jstack \
+                 --slave /usr/bin/jstat jstat ${RPM_INSTALL_PREFIX}/bin/jstat \
+                 --slave /usr/bin/jstatd jstatd ${RPM_INSTALL_PREFIX}/bin/jstatd \
+                 --slave /usr/bin/rmic rmic ${RPM_INSTALL_PREFIX}/bin/rmic \
+                 --slave /usr/bin/serialver serialver ${RPM_INSTALL_PREFIX}/bin/serialver \
+                 --slave /usr/share/man/man1/jar.1 jar.1 ${RPM_INSTALL_PREFIX}/man/man1/jar.1 \
+                 --slave /usr/share/man/man1/jarsigner.1 jarsigner.1 ${RPM_INSTALL_PREFIX}/man/man1/jarsigner.1 \
+                 --slave /usr/share/man/man1/javac.1 javac.1 ${RPM_INSTALL_PREFIX}/man/man1/javac.1 \
+                 --slave /usr/share/man/man1/javadoc.1 javadoc.1 ${RPM_INSTALL_PREFIX}/man/man1/javadoc.1 \
+                 --slave /usr/share/man/man1/javap.1 javap.1 ${RPM_INSTALL_PREFIX}/man/man1/javap.1 \
+                 --slave /usr/share/man/man1/jcmd.1 jcmd.1 ${RPM_INSTALL_PREFIX}/man/man1/jcmd.1 \
+                 --slave /usr/share/man/man1/jconsole.1 jconsole.1 ${RPM_INSTALL_PREFIX}/man/man1/jconsole.1 \
+                 --slave /usr/share/man/man1/jdb.1 jdb.1 ${RPM_INSTALL_PREFIX}/man/man1/jdb.1 \
+                 --slave /usr/share/man/man1/jdeps.1 jdeps.1 ${RPM_INSTALL_PREFIX}/man/man1/jdeps.1 \
+                 --slave /usr/share/man/man1/jinfo.1 jinfo.1 ${RPM_INSTALL_PREFIX}/man/man1/jinfo.1 \
+                 --slave /usr/share/man/man1/jmap.1 jmap.1 ${RPM_INSTALL_PREFIX}/man/man1/jmap.1 \
+                 --slave /usr/share/man/man1/jps.1 jps.1 ${RPM_INSTALL_PREFIX}/man/man1/jps.1 \
+                 --slave /usr/share/man/man1/jrunscript.1 jrunscript.1 ${RPM_INSTALL_PREFIX}/man/man1/jrunscript.1 \
+                 --slave /usr/share/man/man1/jstack.1 jstack.1 ${RPM_INSTALL_PREFIX}/man/man1/jstack.1 \
+                 --slave /usr/share/man/man1/jstat.1 jstat.1 ${RPM_INSTALL_PREFIX}/man/man1/jstat.1 \
+                 --slave /usr/share/man/man1/jstatd.1 jstatd.1 ${RPM_INSTALL_PREFIX}/man/man1/jstatd.1 \
+                 --slave /usr/share/man/man1/rmic.1 rmic.1 ${RPM_INSTALL_PREFIX}/man/man1/rmic.1 \
+                 --slave /usr/share/man/man1/serialver.1 serialver.1 ${RPM_INSTALL_PREFIX}/man/man1/serialver.1 
+fi
diff a/installers/linux/universal/rpm/scripts/preun_java.sh.template b/installers/linux/universal/rpm/scripts/preun_java.sh.template
--- /dev/null
+++ b/installers/linux/universal/rpm/scripts/preun_java.sh.template
@@ -0,0 +1,3 @@
+if [ $1 -eq 0 ] ; then
+    alternatives --remove java ${RPM_INSTALL_PREFIX}/bin/java
+fi
diff a/installers/linux/universal/rpm/scripts/preun_javac.sh.template b/installers/linux/universal/rpm/scripts/preun_javac.sh.template
--- /dev/null
+++ b/installers/linux/universal/rpm/scripts/preun_javac.sh.template
@@ -0,0 +1,3 @@
+if [ $1 -eq 0 ] ; then
+    alternatives --remove javac ${RPM_INSTALL_PREFIX}/bin/javac
+fi
diff a/installers/linux/universal/tar/build.gradle b/installers/linux/universal/tar/build.gradle
--- /dev/null
+++ b/installers/linux/universal/tar/build.gradle
@@ -0,0 +1,201 @@
+/*
+ * Copyright Amazon.com Inc. or its affiliates. All Rights Reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation. Amazon designates this
+ * particular file as subject to the "Classpath" exception as provided
+ * by Oracle in the LICENSE file that accompanied this code.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ */
+
+dependencies {
+    compile project(path: ':openjdksrc', configuration: 'archives')
+    compile project(path: ':prebuild', configuration: 'cacerts')
+}
+
+if (project.correttoArch == 'x86') {
+    project.correttoCommonFlags += '--with-target-bits=32'
+}
+
+def imageDir = "$buildRoot/build/${project.jdkImageName}/images"
+def jdkResultingImage = "${imageDir}/jdk"
+def testResultingImage = "${imageDir}/test"
+
+// deps
+def depsMap = [:]
+project.configurations.compile.getFiles().each { depsMap[it.getName()] = it }
+/**
+ * Create a local copy of the source tree in our
+ * build root -- this is required since OpenJDK's
+ * build wants to occur inside the source tree,
+ * and we don't want to tamper with someone
+ * else's tree.
+ */
+task copySource(type: Exec) {
+    if (!file(buildRoot).exists()) {
+        file(buildRoot).mkdirs()
+    }
+    workingDir '/usr/bin'
+    commandLine 'rsync', '-am',
+            '--exclude=pre-build',
+            '--exclude=installers',
+            '--exclude=corretto-build',
+            "${project.rootDir}/", buildRoot
+}
+
+/**
+ * Scan the patches folder for any .patch that needs
+ * to be applied before start building.
+ */
+task applyPatches() {
+    dependsOn copySource
+    doLast {
+        fileTree('patches').matching {
+            include '*.patch'
+        }.each { f ->
+            ant.patch(patchfile: f, dir: "$buildRoot", strip: 0)
+        }
+    }
+}
+
+task configureBuild(type: Exec) {
+    dependsOn project.configurations.compile
+    dependsOn applyPatches
+    workingDir "$buildRoot"
+
+    // Platform specific flags
+    def command = ['bash', 'configure',
+            "--with-cacerts-file=${depsMap[caCerts]}",
+            "--with-zlib=system"
+    ]
+    // Common flags
+    command += project.correttoCommonFlags
+    commandLine command.flatten()
+
+}
+
+task executeBuild(type: Exec) {
+    dependsOn configureBuild
+    workingDir "$buildRoot"
+    commandLine 'make', 'images'
+    outputs.dir jdkResultingImage
+}
+
+task createTestImage(type: Exec) {
+    dependsOn executeBuild
+    workingDir "$buildRoot"
+    commandLine 'make','test-image'
+}
+
+task bundleThirdPartyBinaries {
+    dependsOn executeBuild
+    doLast {
+        // If property set, copy async profiler binaries to bundle
+        if (project.asyncProfilerBinariesPath != "") {
+            if (!file(project.asyncProfilerBinariesPath).isDirectory()) {
+                throw new GradleException("asyncProfilerBinariesPath is not a valid directory: ${project.asyncProfilerBinariesPath}")
+            }
+            copy {
+                from project.asyncProfilerBinariesPath
+                include 'bin/**', 'lib/**'
+                into jdkResultingImage
+            }
+            copy {
+                from project.asyncProfilerLegal
+                into "${jdkResultingImage}/legal"
+            }
+        }
+    }
+}
+
+task fixCrossCompileLinking(type: Exec) {
+    dependsOn createTestImage
+    /* When cross-compiling for aarch64, gcc incorrectly links against
+     * libz.so, provided by the -devel packages, instead of libz.so.1
+     * This can lead to runtime errors of the form
+     * javac: error while loading shared libraries: libz.so: cannot open shared object file: No such file or directory
+     * As a workaround, use patchelf to update all references to libz.so to the expected libz.so.1
+     *
+     * See also:
+     * - https://github.com/AppImage/AppImageKit/issues/964
+     * - https://github.com/AppImage/AppImageKit/issues/1092
+     * - https://github.com/electron-userland/electron-builder/issues/7835
+     * - https://github.com/CollaboraOnline/richdocumentscode/issues/68
+     * - https://github.com/Sienci-Labs/gsender/issues/420
+     */
+    if (project.hasProperty("corretto.crossCompile")) {
+        commandLine 'bash', '-c', "find ${imageDir} -type f -exec patchelf --replace-needed libz.so libz.so.1 {} \\; 2>/dev/null"
+    } else {
+        commandLine 'bash', '-c', "echo 'Not a cross-compiled build, no linker fixup required'"
+    }
+}
+
+task packageTestImage(type: Tar) {
+    dependsOn fixCrossCompileLinking
+    description = 'Package test results'
+    archiveFileName = "${project.correttoTestImageArchiveName}.tar.gz"
+    compression = Compression.GZIP
+    from(testResultingImage) {
+        include '**'
+    }
+    into project.correttoTestImageArchiveName
+}
+
+task packageDebugSymbols(type: Tar) {
+    description = 'Package debug results'
+    dependsOn packageTestImage
+    archiveFileName = "${project.correttoDebugSymbolsArchiveName}.tar.gz"
+    compression = Compression.GZIP
+    from(jdkResultingImage) {
+        include 'bin/*.diz'
+        include 'lib/*.diz'
+        include 'lib/server/*.diz'
+        into project.correttoDebugSymbolsArchiveName
+    }
+}
+
+task packageBuildResults(type: Tar) {
+    description = 'Compresses the JDK image and puts the results in build/distributions.'
+    dependsOn packageDebugSymbols
+    dependsOn bundleThirdPartyBinaries
+    archiveFileName = "${project.correttoJdkArchiveName}.tar.gz"
+    compression = Compression.GZIP
+    from(buildRoot) {
+        include project.rootFiles
+        into project.correttoJdkArchiveName
+    }
+    from(jdkResultingImage) {
+        include 'bin/**'
+        include 'conf/**'
+        include 'include/**'
+        include 'jmods/**'
+        include 'lib/**'
+        include 'man/man1/**'
+        include 'release'
+        exclude '**/*.diz'
+        into project.correttoJdkArchiveName
+    }
+
+    // Copy legal directory specifically to set permission correctly.
+    // See https://github.com/corretto/corretto-11/issues/129
+    from("${jdkResultingImage}/legal") {
+        include '**'
+        fileMode = 0444
+        into "${project.correttoJdkArchiveName}/legal"
+    }
+}
+
+artifacts {
+    archives packageBuildResults
+}
